package com.hp.user.service.impl;

import com.baomidou.mybatisplus.extension.toolkit.SqlHelper;
import com.hp.user.client.entity.AuditVO;
import com.hp.user.client.service.AuditService;
import com.hp.user.service.dao.AuditMapper;
import com.hp.user.service.entity.Audit;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 审核记录 服务实现类
 * </p>
 *
 * @author 王怡静
 * @since 2020-11-29
 */
@Service
public class AuditServiceImpl implements AuditService {
    @Autowired
    private AuditMapper auditMapper;
    @Override
    public boolean insert(AuditVO audit) {
        Audit temp = new Audit();
        BeanUtils.copyProperties(audit,temp);
        // 判断数据库操作是否成功
        return SqlHelper.retBool(auditMapper.insert(temp));
    }

    @Override
    public AuditVO queryAuditByAuditId(String auditId) {
        AuditVO auditVO = new AuditVO();
        Audit temp = auditMapper.selectById(auditId);
        if(temp == null) return null;
        else {
            BeanUtils.copyProperties(temp, auditVO);
            return auditVO;
        }
    }
}
