package com.hp.user.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.toolkit.SqlHelper;
import com.hp.user.client.entity.CustomerServiceProviderEnterpriseVO;
import com.hp.user.client.service.CustomerServiceProviderEnterpriseService;
import com.hp.user.service.dao.CustomerServiceProviderEnterpriseMapper;
import com.hp.user.service.entity.CustomerServiceProviderEnterprise;
import com.hp.user.service.entity.Station;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 企业和服务商的关系 服务实现类
 * </p>
 *
 * @author 王怡静
 * @since 2020-11-20
 */
@Service
public class CustomerServiceProviderEnterpriseServiceImpl implements CustomerServiceProviderEnterpriseService {
    @Autowired
    private CustomerServiceProviderEnterpriseMapper csMapper;
    @Override
    public boolean insert(CustomerServiceProviderEnterpriseVO cs) {
        CustomerServiceProviderEnterprise temp = new CustomerServiceProviderEnterprise();
        BeanUtils.copyProperties(cs,temp);
        return SqlHelper.retBool(csMapper.insert(temp));
    }

    @Override
    public boolean update(CustomerServiceProviderEnterpriseVO cs) {
        CustomerServiceProviderEnterprise temp = new CustomerServiceProviderEnterprise();
        BeanUtils.copyProperties(cs,temp);
        return SqlHelper.retBool(csMapper.updateById(temp));
    }

    @Override
    public boolean delete(String csId) {
        return SqlHelper.retBool(csMapper.deleteById(csId));
    }

    @Override
    public CustomerServiceProviderEnterpriseVO queryCsByCompanyIdAndServiceProviderId(String companyId, String serviceProviderId) {
        QueryWrapper<CustomerServiceProviderEnterprise> wrapper = new QueryWrapper<>();
        wrapper.eq("service_provider_id",serviceProviderId);
        wrapper.eq("enterprise_id",companyId);
        CustomerServiceProviderEnterprise cs = csMapper.selectOne(wrapper);
        CustomerServiceProviderEnterpriseVO temp = new CustomerServiceProviderEnterpriseVO();
        if(cs == null) return null;
        else {
            BeanUtils.copyProperties(cs,temp);
            return temp;
        }
    }

    @Override
    public String queryServiceProviderIdByCompanyId(String companyId) {
        QueryWrapper<CustomerServiceProviderEnterprise> wrapper = new QueryWrapper<>();
        wrapper.eq("enterprise_id",companyId);
        CustomerServiceProviderEnterprise cs = csMapper.selectOne(wrapper);
        if(cs == null) return null;
        else {
            return cs.getServiceProviderId();
        }
    }

    @Override
    public boolean insertBatch(List<CustomerServiceProviderEnterpriseVO> csVOList) {
        List<CustomerServiceProviderEnterprise> csList = new ArrayList<>();
        CustomerServiceProviderEnterprise temp;
        for(CustomerServiceProviderEnterpriseVO cs:csVOList){
            temp=new CustomerServiceProviderEnterprise();
            BeanUtils.copyProperties(cs,temp);
            csList.add(temp);
        }
        return SqlHelper.retBool(csMapper.insertBatch(csList));
    }

    @Override
    public boolean deleteBatch(List<String> enterpriseIdList) {
        return SqlHelper.retBool(csMapper.deleteBatch(enterpriseIdList));
    }
}
